# Configuration file for the Sphinx documentation builder.
#
# This file only contains a selection of the most common options. For a full
# list see the documentation:
# https://www.sphinx-doc.org/en/master/usage/configuration.html
from __future__ import absolute_import
import sphinx_rtd_theme
# -- Path setup --------------------------------------------------------------

# If extensions (or modules to document with autodoc) are in another directory,
# add these directories to sys.path here. If the directory is relative to the
# documentation root, use os.path.abspath to make it absolute, like shown here.
#
import os
import sys
sys.path.insert(0, os.path.abspath('../src'))
sys.path.insert(0, os.path.abspath('../src/curia/api'))


# -- Project information -----------------------------------------------------

project = 'curia'
copyright = '2020, Curia.ai'
author = 'Curia.ai'


# -- General configuration ---------------------------------------------------

# Add any Sphinx extension module names here, as strings. They can be
# extensions coming with Sphinx (named 'sphinx.ext.*') or your custom
# ones.
extensions = [
    # "sphinx.ext.todo",
    # "sphinx.ext.coverage",
    # "sphinx.ext.autosummary",
    "sphinx.ext.napoleon",
    # "sphinx.ext.autosectionlabel",
    "sphinxcontrib.apidoc"
]

# Add any paths that contain templates here, relative to this directory.
templates_path = ['_templates']

source_suffix = ".rst"  # The suffix of source filenames.
master_doc = "index"  # The master toctree document.

# List of patterns, relative to source directory, that match files and
# directories to ignore when looking for source files.
# This pattern also affects html_static_path and html_extra_path.
exclude_patterns = ['_build', 'Thumbs.db', '.DS_Store', 'api']

pygments_style = "default"

autoclass_content = "both"
autodoc_default_flags = ["members"]
autodoc_member_order = "bysource"
autodoc_docstring_signature = False
autodoc_mock_imports = ["numpy", "pandas", "sklearn"]

# autosummary
autosummary_generate = True

# autosectionlabel
autosectionlabel_prefix_document = True

apidoc_module_dir = '../src/curia'
apidoc_output_dir = 'reference'
apidoc_excluded_paths = ['api/*']
apidoc_separate_modules = True


# -- Options for HTML output -------------------------------------------------

# The theme to use for HTML and HTML Help pages.  See the documentation for
# a list of builtin themes.
#
html_theme = 'sphinx_rtd_theme'
html_theme_path = [sphinx_rtd_theme.get_html_theme_path()]
# Add any paths that contain custom static files (such as style sheets) here,
# relative to this directory. They are copied after the builtin static files,
# so a file named "default.css" will overwrite the builtin "default.css".
html_static_path = ['_static']